## pbbam 0.7.0

=== CMakeLists.txt ===
########################################################################
# CMake build script for PacBioBAM library.
########################################################################

cmake_policy(SET CMP0048 NEW)  # lets us set version in project()
project(PacBioBAM VERSION 0.7.0 LANGUAGES CXX C)
cmake_minimum_required(VERSION 3.0)

# project name & version
set(PacBioBAM_NAME pbbam)
set(PacBioBAM_VERSION
  "${PacBioBAM_VERSION_MAJOR}.${PacBioBAM_VERSION_MINOR}.${PacBioBAM_VERSION_PATCH}"
)

# list build-time options
option(PacBioBAM_build_docs    "Build PacBioBAM's API documentation."                   ON)
option(PacBioBAM_build_tests   "Build PacBioBAM's unit tests."                          ON)
option(PacBioBAM_build_shared  "Build PacBioBAM as shared library as well."             OFF)
option(PacBioBAM_build_tools   "Build PacBioBAM command line utilities (e.g. pbindex)"  ON)
option(PacBioBAM_wrap_csharp   "Build PacBioBAM with SWIG bindings for C#."             OFF)
option(PacBioBAM_wrap_python   "Build PacBioBAM with SWIG bindings for Python."         OFF)
option(PacBioBAM_wrap_r        "Build PacBioBAM with SWIG bindings for R."              OFF)
option(PacBioBAM_use_modbuild  "Build PacBioBAM using Modular Build System."            OFF)
option(PacBioBAM_use_ccache    "Build PacBioBAM using ccache, if available."            ON)
option(PacBioBAM_auto_validate "Build PacBioBAM with auto-validation enabled."          OFF)

# enable ccache, if available 
if(PacBioBAM_use_ccache)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK    ccache)
    endif()
endif()

# Deprecating the "PacBioBAM_build_pbindex" command line option in favor of more
# general "PacBioBAM_build_tools", as we're starting to add new utilities.
#
# That said, I don't want to break current auto tests/builds, so I'm providing a
# warning message so devs are aware.
#
if(DEFINED PacBioBAM_build_pbindex)

    # construct warning message
    set(pbindex_warning "\nDeprecated:\n-DPacBioBAM_build_pbindex\n")
    if (PacBioBAM_build_pbindex)
        set(pbindex_warning "${pbindex_warning} Building as requested,")
    else()
        set(pbindex_warning "${pbindex_warning} Skipping as requested,")
    endif()
    set(pbindex_warning "${pbindex_warning} but support for this option will be removed at some point in the future.\n")
    message(AUTHOR_WARNING "${pbindex_warning} ** Use -DPacBioBAM_build_tools instead. **\n")

    # force PacBioBAM_build_tools option
    set(PacBioBAM_build_tools ${PacBioBAM_build_pbindex} CACHE BOOL
        "Build PacBioBAM with add'l utilities (e.g. pbindex, pbindexdump)." FORCE)
endif()

# enable testing if requested
if(PacBioBAM_build_tests)
    enable_testing()
endif()

# determine if we're generating SWIG bindings
if(PacBioBAM_wrap_csharp OR PacBioBAM_wrap_r OR PacBioBAM_wrap_python)
    set(wrapping_swig TRUE)
else()
    set(wrapping_swig FALSE)
endif()

# determine if we need a shared lib
if(PacBioBAM_build_shared OR wrapping_swig)
    set(BUILD_SHARED_LIBS ON)
    set(htslib_build_shared ON CACHE BOOL "force htslibConfig to export proper library name")
    set(PB_LIB_MODE SHARED)
    set(PB_LIB_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
else()
    set(BUILD_SHARED_LIBS OFF)
    set(PB_LIB_MODE STATIC)
    set(PB_LIB_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
endif()
    
# main project paths
set(PacBioBAM_RootDir       ${PacBioBAM_SOURCE_DIR})
set(PacBioBAM_DocsDir       ${PacBioBAM_RootDir}/docs)
set(PacBioBAM_IncludeDir    ${PacBioBAM_RootDir}/include)
set(PacBioBAM_SourceDir     ${PacBioBAM_RootDir}/src)
set(PacBioBAM_SwigSourceDir ${PacBioBAM_RootDir}/src/swig)
set(PacBioBAM_TestsDir      ${PacBioBAM_RootDir}/tests)
set(PacBioBAM_ToolsDir      ${PacBioBAM_RootDir}/tools)

if(NOT PacBioBAM_OutputDir)
    set(PacBioBAM_OutputDir ${PacBioBAM_RootDir})
else()
    # if SWIG bindings requested
    if(${wrapping_swig})
        message(FATAL_ERROR "SWIG bindings not currently supported in modular build.")
    endif()
endif()

set(PacBioBAM_BinDir        ${PacBioBAM_OutputDir}/bin)
set(PacBioBAM_LibDir        ${PacBioBAM_OutputDir}/lib)
set(PacBioBAM_ThirdPartyDir ${PacBioBAM_RootDir}/third-party)

file(MAKE_DIRECTORY ${PacBioBAM_BinDir})
file(MAKE_DIRECTORY ${PacBioBAM_LibDir})

# use some custom Find*, Use* cmake modules
list(APPEND CMAKE_MODULE_PATH "${PacBioBAM_RootDir}/cmake")

# shared & third-party paths
if(NOT HTSLIB_INCLUDE_DIRS OR
   NOT HTSLIB_LIBRARIES)
    if(HTSLIB_ROOTDIR)
        find_package(htslib
                     PATHS ${HTSLIB_ROOTDIR}/
                     REQUIRED)
    else()
        find_package(htslib
                     PATHS ${PacBioBAM_SOURCE_DIR}/../htslib/
                     REQUIRED)
    endif()
endif()

if(NOT Boost_INCLUDE_DIRS)
    find_package(Boost REQUIRED)
endif()

if (NOT ZLIB_INCLUDE_DIRS OR
    NOT ZLIB_LIBRARIES)
    find_package(ZLIB REQUIRED)
endif()

# shared CXX flags for src & tests
if (MSVC)
    set(PacBioBAM_CXX_FLAGS "/Wall")
else()
    set(PacBioBAM_CXX_FLAGS "-std=c++11 -Wall -Wno-sign-compare")
endif()

# NOTE: -Wno-unused-local-typedefs used to quash clang warnings w/ Boost
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-unused-local-typedefs" HAS_NO_UNUSED_LOCAL_TYPEDEFS)
if(HAS_NO_UNUSED_LOCAL_TYPEDEFS)
    set(PacBioBAM_CXX_FLAGS "${PacBioBAM_CXX_FLAGS} -Wno-unused-local-typedefs")
endif()

if(PacBioBAM_auto_validate)
    add_definitions("-DPBBAM_AUTOVALIDATE=1")
endif()

# For now, keep @rpath out of install names on OS X, as it causes SWIG
# tests to fail.
if(APPLE)
    set(CMAKE_MACOSX_RPATH OFF)
endif()

# Turn on windows-style filepath resolution.
# We need to add this #define early (not just in the C# SWIG wrapper)
if(WIN32 AND PacBioBAM_wrap_csharp)
    add_definitions(-DPBBAM_WIN_FILEPATHS)
endif()

# keep this order (src first, at least)
add_subdirectory(src)

if(PacBioBAM_build_tools)
    add_subdirectory(tools)
endif()

if(PacBioBAM_build_docs)
    add_subdirectory(docs)
endif()

if(PacBioBAM_build_tests)

    if (NOT GTEST_SRC_DIR)
        set(PREBUILT_GTEST_SRC ${PacBioBAM_RootDir}/../../../../prebuilt.tmpout/gtest/gtest_1.7.0/)
        if(EXISTS ${PREBUILT_GTEST_SRC})
            set(GTEST_SRC_DIR ${PREBUILT_GTEST_SRC})
        else()
            set(GTEST_SRC_DIR ../gtest) # keep old fallback behavior for external builds, for now at least
        endif()
    endif()

    add_subdirectory(${GTEST_SRC_DIR} external/gtest/build)
    add_subdirectory(tests)

endif()

=== src/CMakeLists.txt ===
find_package(Threads)

if(WIN32)
  # Need winsock on windows
  set(SOCKET_LIBRARIES "ws2_32")

  # Limit the number of DLLs we will have to bundle
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc -static-libstdc++")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc -static-libstdc++")
endif()

# define PacBioBAM library dependencies
set(PacBioBAM_DependencyIncludes
    ${Boost_INCLUDE_DIRS}
    ${HTSLIB_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)
set(PacBioBAM_DependencyLibraries
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${SOCKET_LIBRARIES}
)

# set up library include dirs
include_directories(SYSTEM
    ${PacBioBAM_DependencyIncludes}
)

include_directories(
    ${PacBioBAM_IncludeDir}
)

# grab library source files
include(files.cmake)
set(SOURCES
    ${PacBioBAM_H}
    ${PacBioBAM_CPP}
)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

# define actual library
add_definitions(-DPBBAM_LIBRARY)
if(PacBioBAM_wrap_r)
    # SWIG R does not support PBBAM_SHARED_PTR, but it does support boost::shared_ptr
    # So force boost if we're wrapping for R.
    add_definitions(-DPBBAM_USE_BOOST_SHARED_PTR)
endif()

add_library(pbbam ${SOURCES})
set_target_properties(pbbam PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
    RUNTIME_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
    LIBRARY_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
)
        
# link dependency libs to pbbam 
target_link_libraries(pbbam ${PacBioBAM_DependencyLibraries})
target_include_directories(pbbam 
    PUBLIC
    ${PacBioBAM_IncludeDir} 
    ${PacBioBAM_DependencyIncludes}
)

# define symbols for projects that use PacBioBAM
set(PacBioBAM_INCLUDE_DIRS
    ${PacBioBAM_IncludeDir} ${PacBioBAM_DependencyIncludes}
    CACHE INTERNAL
    "${PROJECT_NAME}: Include Directories"
    FORCE
)

set(PacBioBAM_LIBRARIES
    ${PacBioBAM_LibDir}/libpbbam${PB_LIB_SUFFIX} ${PacBioBAM_DependencyLibraries}
    CACHE INTERNAL
    "${PROJECT_NAME}: Libraries"
    FORCE
)

if(${wrapping_swig})
    # add SWIG directory
    add_subdirectory(swig)
endif()  # swig

=== tests/CMakeLists.txt ===
find_package(Threads REQUIRED)

# ensure output directories exists
file(MAKE_DIRECTORY ${PacBioBAM_TestsDir}/bin)
set(GeneratedTestDataDir ${CMAKE_BINARY_DIR}/generated/data)
file(MAKE_DIRECTORY ${GeneratedTestDataDir})

# generate paths/values used by for unit tests
configure_file(
    ${PacBioBAM_TestsDir}/src/TestData.h.in
    ${PacBioBAM_TestsDir}/src/TestData.h
)
configure_file(
    ${PacBioBAM_TestsDir}/data/group/group.fofn.in
    ${PacBioBAM_TestsDir}/data/group/group.fofn
)

# add PacBioBAM & GoogleTest includes
include_directories(
    ${PacBioBAM_INCLUDE_DIRS}
    ${gtest_SOURCE_DIR}/include 
    ${gtest_SOURCE_DIR}
)

# grab PacBioBAM unit test source files
include(files.cmake)
set(SOURCES
    ${PacBioBAMTest_H}
    ${PacBioBAMTest_CPP}
)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

# define unit test executable
add_definitions(-DPBBAM_TESTING)
if(MSVC)
    # VS2012+ pooh-pooh's Derek's "#define private public" trick
    add_definitions(-D_ALLOW_KEYWORD_MACROS)
endif()

if(PacBioBAM_wrap_r)
    # SWIG R does not support std::shared_ptr, but it does support boost::shared_ptr
    # So force boost if we're wrapping for R.
    add_definitions(-DPBBAM_USE_BOOST_SHARED_PTR)
endif()
add_executable(test_pbbam ${SOURCES})
set_target_properties(test_pbbam PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PacBioBAM_TestsDir}/bin
)

# generate test data
add_custom_target(
    generate_test_data
    WORKING_DIRECTORY ${PacBioBAM_TestsDir}/scripts
    COMMAND "python" generate_data.py
        ${PacBioBAM_TestsDir}/data/
        ${GeneratedTestDataDir}
        baz
)

# add unit tests to test framework
add_test(
    NAME UnitTests
    WORKING_DIRECTORY ${PacBioBAM_TestsDir}/bin
    COMMAND test_pbbam
)
add_dependencies(test_pbbam pbbam generate_test_data)
target_link_libraries(test_pbbam
    ${PacBioBAM_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT} # quirky pthreads 
    gtest
    gtest_main
)

=== tools/CMakeLists.txt ===

set(ToolsCommonDir ${PacBioBAM_ToolsDir}/common)
set(PacBioBAM_CramTestsDir ${PacBioBAM_TestsDir}/src/cram)

# quash warning with OptionParser
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
if(HAS_NO_UNUSED_PRIVATE_FIELD)
    set(PacBioBAM_CXX_FLAGS "${PacBioBAM_CXX_FLAGS} -Wno-unused-private-field")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

# tools
add_subdirectory(bam2sam)
add_subdirectory(pbindex)
add_subdirectory(pbindexdump)
add_subdirectory(pbmerge)

=== src/swig/CMakeLists.txt ===
# --------------------------------------------- @
# SWIG
# --------------------------------------------- @

# general SWIG
if(${wrapping_swig})

    find_package(SWIG 3.0.5 REQUIRED)

    include(${SWIG_USE_FILE})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR})

    #
    # quash compiler warnings from SWIG-generated code
    #
    check_cxx_compiler_flag("-Wno-unused-local-typedefs" HAS_NO_UNUSED_BUT_SET_VARIABLE)
    if(HAS_NO_UNUSED_BUT_SET_VARIABLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-but-set-variable")
    endif()

    check_cxx_compiler_flag("-Wno-dynamic-class-memaccess" HAS_NO_DYNAMIC_CLASS_MEMACCESS)
    if (HAS_NO_DYNAMIC_CLASS_MEMACCESS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-dynamic-class-memaccess")
    endif()

    check_cxx_compiler_flag("-Wno-unused-parameter" HAS_NO_UNUSED_PARAMETER)
    if (HAS_NO_UNUSED_PARAMETER)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
    endif()

    check_cxx_compiler_flag("-Wno-return-local-addr" HAS_NO_RETURN_LOCAL_ADDR)
    if (HAS_NO_RETURN_LOCAL_ADDR)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-local-addr")
    endif()

    check_cxx_compiler_flag("-Wno-return-type" HAS_NO_RETURN_TYPE)
    if (HAS_NO_RETURN_TYPE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type")
    endif()

    #
    # SWIG source file properties
    #
    set_source_files_properties(PacBioBam.i PROPERTIES CPLUSPLUS ON)

    if (APPLE)
    else()
        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set_source_files_properties(PacBioBam.i PROPERTIES SWIG_FLAGS "-DSWIGWORDSIZE64")
        endif()
    endif()

endif()

# Python
if(PacBioBAM_wrap_python)
    include(WrapPython.cmake)
endif()

# R
if(PacBioBAM_wrap_r)
    include(WrapR.cmake)
endif()

# CSharp
if(PacBioBAM_wrap_csharp)
    include(WrapCSharp.cmake)
endif()

=== tools/bam2sam/CMakeLists.txt ===

set(Bam2SamSrcDir ${PacBioBAM_ToolsDir}/bam2sam/src)

# create version header
set(Bam2Sam_VERSION ${PacBioBAM_VERSION})
configure_file(
    ${Bam2SamSrcDir}/Bam2SamVersion.h.in Bam2SamVersion.h @ONLY
)

# list source files
set(BAM2SAM_SOURCES
    ${ToolsCommonDir}/OptionParser.cpp
    ${Bam2SamSrcDir}/main.cpp
    ${Bam2SamSrcDir}/Bam2Sam.cpp
)

# build bam2sam executable
include(PbbamTool)
create_pbbam_tool(
    TARGET  bam2sam
    SOURCES ${BAM2SAM_SOURCES}
)

# cram tests
if (PacBioBAM_build_tests)
    add_test(
        NAME bam2sam_CramTests
        WORKING_DIRECTORY ${PacBioBAM_TestsDir}/scripts
        COMMAND "python" cram.py
            ${PacBioBAM_CramTestsDir}/bam2sam.t
    )
endif()

=== tools/pbindex/CMakeLists.txt ===

set(PbindexSrcDir ${PacBioBAM_ToolsDir}/pbindex/src)

# create version header
set(PbIndex_VERSION ${PacBioBAM_VERSION})
configure_file(
    ${PbindexSrcDir}/PbIndexVersion.h.in PbIndexVersion.h @ONLY
)

# list source files
set(PBINDEX_SOURCES
    ${ToolsCommonDir}/OptionParser.cpp
    ${PbindexSrcDir}/main.cpp
    ${PbindexSrcDir}/PbIndex.cpp
)

# build pbindex executable
include(PbbamTool)
create_pbbam_tool(
    TARGET  pbindex
    SOURCES ${PBINDEX_SOURCES}
)

=== tools/pbindexdump/CMakeLists.txt ===

set(PbindexdumpSrcDir ${PacBioBAM_ToolsDir}/pbindexdump/src)

# create version header
set(PbIndexDump_VERSION ${PacBioBAM_VERSION})
configure_file(
    ${PbindexdumpSrcDir}/PbIndexDumpVersion.h.in PbIndexDumpVersion.h @ONLY
)

# list source files
set(PBINDEXDUMP_SOURCES
    ${ToolsCommonDir}/OptionParser.cpp
    ${PbindexdumpSrcDir}/CppFormatter.cpp
    ${PbindexdumpSrcDir}/JsonFormatter.cpp
    ${PbindexdumpSrcDir}/PbIndexDump.cpp
    ${PbindexdumpSrcDir}/main.cpp
)

# build pbindexdump executable
include(PbbamTool)
create_pbbam_tool(
    TARGET  pbindexdump
    SOURCES ${PBINDEXDUMP_SOURCES}
)

# cram tests
if (PacBioBAM_build_tests)
    add_test(
        NAME pbindexdump_CramTests
        WORKING_DIRECTORY ${PacBioBAM_TestsDir}/scripts
        COMMAND "python" cram.py
            ${PacBioBAM_CramTestsDir}/pbindexdump_json.t
            ${PacBioBAM_CramTestsDir}/pbindexdump_cpp.t
    )
endif()

=== tools/pbmerge/CMakeLists.txt ===

set(PbmergeSrcDir ${PacBioBAM_ToolsDir}/pbmerge/src)

# create version header
set(PbMerge_VERSION ${PacBioBAM_VERSION})
configure_file(
    ${PbmergeSrcDir}/PbMergeVersion.h.in PbMergeVersion.h @ONLY
)

# list source files
set(PBMERGE_SOURCES
    ${ToolsCommonDir}/BamFileMerger.h
    ${ToolsCommonDir}/OptionParser.cpp
    ${PbmergeSrcDir}/main.cpp
)

# build pbmerge executable
include(PbbamTool)
create_pbbam_tool(
    TARGET  pbmerge
    SOURCES ${PBMERGE_SOURCES}
)

# cram tests
if (PacBioBAM_build_tests)
    if(PacBioBAM_auto_validate)
        # skip for now til we clean up merge tests under autovalidate, too
    else()
        add_test(
        NAME pbmerge_CramTests
        WORKING_DIRECTORY ${PacBioBAM_TestsDir}/scripts
        COMMAND "python" cram.py
            ${PacBioBAM_CramTestsDir}/pbmerge_pacbio_ordering.t
            ${PacBioBAM_CramTestsDir}/pbmerge_aligned_ordering.t
            ${PacBioBAM_CramTestsDir}/pbmerge_mixed_ordering.t
            ${PacBioBAM_CramTestsDir}/pbmerge_dataset.t
            ${PacBioBAM_CramTestsDir}/pbmerge_fofn.t
    )
    endif()
endif()

## pbbam 0.7.4%2Bds

=== src/swig/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
     find_package(SWIG 3.0.5 REQUIRED)
 
     include(${SWIG_USE_FILE})
-    include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+    include_directories(${PacBioBAM_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
 
     #
     # quash compiler warnings from SWIG-generated code

## pbbam 0.7.4+ds

=== CMakeLists.txt ===
########################################################################
# CMake build script for PacBioBAM library.
########################################################################

cmake_policy(SET CMP0048 NEW)  # lets us set version in project()
project(PacBioBAM VERSION 0.7.4 LANGUAGES CXX C)
cmake_minimum_required(VERSION 3.0)

# project name & version
set(PacBioBAM_NAME pbbam)
set(PacBioBAM_VERSION
  "${PacBioBAM_VERSION_MAJOR}.${PacBioBAM_VERSION_MINOR}.${PacBioBAM_VERSION_PATCH}"
)

# list build-time options
option(PacBioBAM_build_docs    "Build PacBioBAM's API documentation."                   ON)
option(PacBioBAM_build_tests   "Build PacBioBAM's unit tests."                          ON)
option(PacBioBAM_build_shared  "Build PacBioBAM as shared library as well."             OFF)
option(PacBioBAM_build_tools   "Build PacBioBAM command line utilities (e.g. pbindex)"  ON)
option(PacBioBAM_wrap_csharp   "Build PacBioBAM with SWIG bindings for C#."             OFF)
option(PacBioBAM_wrap_python   "Build PacBioBAM with SWIG bindings for Python."         OFF)
option(PacBioBAM_wrap_r        "Build PacBioBAM with SWIG bindings for R."              OFF)
option(PacBioBAM_use_modbuild  "Build PacBioBAM using Modular Build System."            OFF)
option(PacBioBAM_use_ccache    "Build PacBioBAM using ccache, if available."            ON)
option(PacBioBAM_auto_validate "Build PacBioBAM with auto-validation enabled."          OFF)

if (PacBioBAM_wrap_csharp OR PacBioBAM_wrap_r OR PacBioBAM_wrap_python)
    set(wrapping_swig TRUE)
else()
    set(wrapping_swig FALSE)
endif()

if(PacBioBAM_build_tests)
    enable_testing()
endif()

# project paths
set(PacBioBAM_RootDir       ${CMAKE_CURRENT_LIST_DIR})
set(PacBioBAM_DocsDir       ${PacBioBAM_RootDir}/docs)
set(PacBioBAM_IncludeDir    ${PacBioBAM_RootDir}/include)
set(PacBioBAM_SourceDir     ${PacBioBAM_RootDir}/src)
set(PacBioBAM_SwigSourceDir ${PacBioBAM_RootDir}/src/swig)
set(PacBioBAM_TestsDir      ${PacBioBAM_RootDir}/tests)
set(PacBioBAM_ThirdPartyDir ${PacBioBAM_RootDir}/third-party)
set(PacBioBAM_ToolsDir      ${PacBioBAM_RootDir}/tools)

if(NOT PacBioBAM_OutputDir)
    set(PacBioBAM_OutputDir ${CMAKE_CURRENT_BINARY_DIR})
else()
    if(${wrapping_swig})
        message(FATAL_ERROR "SWIG bindings not currently supported in modular build.")
    endif()
endif()
set(PacBioBAM_BinDir    ${PacBioBAM_OutputDir}/bin)
set(PacBioBAM_LibDir    ${PacBioBAM_OutputDir}/lib)

set(GeneratedDir ${CMAKE_BINARY_DIR}/generated)
set(GeneratedTestDataDir ${GeneratedDir}/data)
file(MAKE_DIRECTORY ${PacBioBAM_BinDir})
file(MAKE_DIRECTORY ${PacBioBAM_LibDir})
file(MAKE_DIRECTORY ${GeneratedDir})
file(MAKE_DIRECTORY ${GeneratedTestDataDir})

# project configuration (keep this order)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake ${CMAKE_MODULE_PATH})
include(pbbam-ccache)
include(pbbam-compilerflags)
include(pbbam-libtype)
include(pbbam-dependencies)

# project components (keep this order)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(docs)
add_subdirectory(tests)

=== src/CMakeLists.txt ===

# grab library source files
include(files.cmake)
set(SOURCES
    ${PacBioBAM_H}
    ${PacBioBAM_CPP}
)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

# define actual library
add_library(pbbam ${SOURCES})

# library properties
target_compile_definitions(pbbam
    PRIVATE "-DPBBAM_LIBRARY"
)
set_target_properties(pbbam PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
    RUNTIME_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
    LIBRARY_OUTPUT_DIRECTORY ${PacBioBAM_LibDir}
)

if(PacBioBAM_wrap_r)
    # SWIG R does not support std::shared_ptr, but it does support boost::shared_ptr
    # So force boost if we're wrapping for R.
    target_compile_definitions(pbbam
        PUBLIC -DPBBAM_USE_BOOST_SHARED_PTR
    )
endif()

if(PacBioBAM_auto_validate)
    target_compile_definitions(pbbam
        PUBLIC "-DPBBAM_AUTOVALIDATE=1"
    )
endif()

# pbbam includes
target_include_directories(pbbam
    PUBLIC
    ${PacBioBAM_IncludeDir}
    ${HTSLIB_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)

# set link dependencies
#   if htslib provided externally
if(HTSLIB_LIBRARIES)
    set(pbbam_all_dependency_libs
        ${HTSLIB_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${SOCKET_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
    )
# otherwise, use the "in-project" htslib target
else()
    set(pbbam_all_dependency_libs
        $<TARGET_FILE:hts>
        ${ZLIB_LIBRARIES}
        ${SOCKET_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
    )
endif()

target_link_libraries(pbbam
    PUBLIC
    ${pbbam_all_dependency_libs}
)

# define include paths for projects that use pbbam
set(PacBioBAM_INCLUDE_DIRS
    ${PacBioBAM_IncludeDir}
    ${HTSLIB_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    CACHE INTERNAL
    "${PROJECT_NAME}: Include Directories"
    FORCE
)
set(PacBioBAM_LIBRARIES
    $<TARGET_FILE:pbbam>
    ${pbbam_all_dependency_libs}
    CACHE INTERNAL
    "${PROJECT_NAME}: Libraries"
    FORCE
)

# add SWIG directory
add_subdirectory(swig)

=== tests/CMakeLists.txt ===

if(PacBioBAM_build_tests)

    # setup GoogleTest
    if (NOT GTEST_SRC_DIR)
        set(PREBUILT_GTEST_SRC ${PacBioBAM_RootDir}/../../../../prebuilt.tmpout/gtest/gtest_1.7.0/)
        if(EXISTS ${PREBUILT_GTEST_SRC})
            set(GTEST_SRC_DIR ${PREBUILT_GTEST_SRC})
        else()
            set(GTEST_SRC_DIR ${PacBioBAM_RootDir}/../gtest) # keep old fallback behavior for external builds, for now at least
        endif()
    endif()
    add_subdirectory(${GTEST_SRC_DIR} external/gtest/build)

    # generate paths/values used by for unit tests
    configure_file(
        ${PacBioBAM_TestsDir}/src/TestData.h.in
        ${CMAKE_BINARY_DIR}/generated/TestData.h
    )
    configure_file(
        ${PacBioBAM_TestsDir}/data/group/group.fofn.in
        ${CMAKE_BINARY_DIR}/generated/group.fofn
    )

    # grab PacBioBAM unit test source files
    include(files.cmake)
    set(SOURCES
        ${PacBioBAMTest_H}
        ${PacBioBAMTest_CPP}
    )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

    # define unit test executable
    add_definitions(-DPBBAM_TESTING)
    if(MSVC)
        # VS2012+ pooh-pooh's Derek's "#define private public" trick
        add_definitions(-D_ALLOW_KEYWORD_MACROS)
    endif()

    if(PacBioBAM_wrap_r)
        # SWIG R does not support std::shared_ptr, but it does support boost::shared_ptr
        # So force boost if we're wrapping for R.
        add_definitions(-DPBBAM_USE_BOOST_SHARED_PTR)
    endif()

    add_executable(test_pbbam ${SOURCES})
    set_target_properties(test_pbbam PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${PacBioBAM_BinDir}
    )
    target_include_directories(test_pbbam
        PUBLIC
        ${CMAKE_BINARY_DIR}/generated
        ${PacBioBAM_INCLUDE_DIRS}
        ${gtest_SOURCE_DIR}/include
        ${gtest_SOURCE_DIR}
    )

    # generate test data
    add_custom_target(
        generate_test_data
        WORKING_DIRECTORY ${PacBioBAM_TestsDir}/scripts
        COMMAND "python" generate_data.py
            ${PacBioBAM_TestsDir}/data/
            ${GeneratedTestDataDir}
    )

    # add unit tests to test framework
    add_test(
        NAME UnitTests
        WORKING_DIRECTORY ${PacBioBAM_BinDir}
        COMMAND test_pbbam
    )
    add_dependencies(test_pbbam generate_test_data)
    target_link_libraries(test_pbbam
        pbbam
        ${CMAKE_THREAD_LIBS_INIT} # quirky pthreads
        gtest
        gtest_main
    )
endif() # PacBioBAM_build_tests

=== tools/CMakeLists.txt ===


if(DEFINED PacBioBAM_build_pbindex)

    # Deprecating the "PacBioBAM_build_pbindex" command line option in favor of more
    # general "PacBioBAM_build_tools", as we're starting to add new utilities.
    #
    # That said, I don't want to break current auto tests/builds, so I'm providing a
    # warning message so devs are aware.
    #
    # construct warning message
    set(pbindex_warning "\nDeprecated:\n-DPacBioBAM_build_pbindex\n")
    if (PacBioBAM_build_pbindex)
        set(pbindex_warning "${pbindex_warning} Building as requested,")
    else()
        set(pbindex_warning "${pbindex_warning} Skipping as requested,")
    endif()
    set(pbindex_warning "${pbindex_warning} but support for this option will be removed at some point in the future.\n")
    message(AUTHOR_WARNING "${pbindex_warning} ** Use -DPacBioBAM_build_tools instead. **\n")

    # force PacBioBAM_build_tools option
    set(PacBioBAM_build_tools
        ${PacBioBAM_build_pbindex} CACHE BOOL
        "Build PacBioBAM with add'l utilities (e.g. pbindex, pbindexdump)." FORCE)
endif()

if (PacBioBAM_build_tools)

    # tools directory
    set(ToolsCommonDir ${PacBioBAM_ToolsDir}/common)
    set(PacBioBAM_CramTestsDir ${PacBioBAM_TestsDir}/src/cram)

    # quash warning with OptionParser
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
    if(HAS_NO_UNUSED_PRIVATE_FIELD)
        set(PacBioBAM_CXX_FLAGS "${PacBioBAM_CXX_FLAGS} -Wno-unused-private-field")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PacBioBAM_CXX_FLAGS}")

    # tools
    add_subdirectory(bam2sam)
    add_subdirectory(pbindex)
    add_subdirectory(pbindexdump)
    add_subdirectory(pbmerge)

endif()

=== debian/changelog ===
pbbam (0.7.4+ds-1build2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:55:00 +0000

pbbam (0.7.4+ds-1build1) artful; urgency=medium

  * No-change rebuild against libhts2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Jun 2017 07:29:38 +0000

pbbam (0.7.4+ds-1) unstable; urgency=medium

  * New upstream release snapshot
    - Exclude dependency convenience copy
    - Update patches
    - Update running of tests at build-time
    - Update .install files
    - Update autopkgtest commands
  * Use debhelper compat 10
  * libpbbam-dev: depend on libssl-dev

 -- Afif Elghraoui <afif@debian.org>  Sat, 21 Jan 2017 23:48:21 -0800

pbbam (0.7.0-1) unstable; urgency=medium

  * Imported Upstream version 0.7.0
  * Update patches

 -- Afif Elghraoui <afif@debian.org>  Sun, 30 Oct 2016 14:31:49 -0700

pbbam (0.5.0-3) unstable; urgency=low

  * Fix cmake arguments to properly position LDFLAGS for -Wl,--as-needed.
    Thanks to Steve Langasek (Closes: #841671)

 -- Afif Elghraoui <afif@debian.org>  Sun, 23 Oct 2016 14:07:27 -0700

pbbam (0.5.0-2) unstable; urgency=low

  * libpbbam-dev: add dependency on libhts-dev

 -- Afif Elghraoui <afif@debian.org>  Sun, 17 Jul 2016 23:29:34 -0700

pbbam (0.5.0-1) unstable; urgency=medium

  * New upstream revision (git 79ab246 from 2016-02-23)
  * Declare additional copyrights to avoid repacking tarball
  * Update patches
  * Update Standards-Version to 3.9.8
  * Use encrypted protocols for VCS URLs
  * Clean up d/control and d/rules
  * Use dh-exec for library installation rather than sed-within-d/rules
  * Set up build-time tests for command-line tools
  * Add binary package for command-line tools
  * Install library to main library path
  * Configure autopkgtests
  * Use documentation page as Homepage
  * Remove build-dependency on doxygen
  * Add TODO list

 -- Afif Elghraoui <afif@debian.org>  Tue, 05 Jul 2016 03:25:49 -0700

pbbam (0.1.0~20150813+git4e9e417+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #798220)

 -- Afif Elghraoui <afif@ghraoui.name>  Fri, 18 Sep 2015 02:40:24 -0700

=== debian/control ===
Source: pbbam
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Build-Depends:
	debhelper (>= 10),
	dh-exec,
	cmake,
	python,
#	swig3.0,
	libboost-dev (>= 1.54),
	zlib1g-dev,
	libssl-dev,
	libhts-dev,
# Test-Depends:
#	libgtest-dev,
	python-cram,
	samtools,
Standards-Version: 3.9.8
Homepage: http://pbbam.readthedocs.org/en/latest/index.html
Vcs-Git: https://anonscm.debian.org/git/debian-med/pbbam.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/pbbam.git

Package: pbbamtools
Section: science
Architecture: any
Depends:
	${shlibs:Depends},
	${misc:Depends},
	libpbbam (= ${binary:Version}),
Recommends: samtools
Description: processing Pacific Biosciences binary alignment/map files
 The BAM format is a binary, compressed, record-oriented container format
 for raw or aligned sequence reads. The associated SAM format is a text
 representation of the same data. The specifications for BAM/SAM are maintained
 by the SAM/BAM Format Specification Working Group.
 .
 PacBio-produced BAM files are fully compatible with the BAM specification,
 but makes use of the extensibility mechanisms of the BAM specification to
 encode PacBio-specific information.
 .
 This package provides command-line utilities for working with PacBio BAM
 files.

Package: libpbbam
Architecture: any
Multi-Arch: same
Pre-Depends:
	${misc:Pre-Depends}
Depends:
	${shlibs:Depends},
	${misc:Depends},
Description: Pacific Biosciences binary alignment/map (BAM) library
 The BAM format is a binary, compressed, record-oriented container format
 for raw or aligned sequence reads. The associated SAM format is a text
 representation of the same data. The specifications for BAM/SAM are maintained
 by the SAM/BAM Format Specification Working Group.
 .
 PacBio-produced BAM files are fully compatible with the BAM specification,
 but makes use of the extensibility mechanisms of the BAM specification to
 encode PacBio-specific information. The pbbam library provides tools to
 work with these files

Package: libpbbam-dev
Section: libdevel
Architecture: any
Depends:
	libpbbam (= ${binary:Version}),
	libhts-dev,
	libssl-dev,
	${misc:Depends},
Description: Pacific Biosciences binary alignment/map (BAM) library (headers)
 The BAM format is a binary, compressed, record-oriented container format
 for raw or aligned sequence reads. The associated SAM format is a text
 representation of the same data. The specifications for BAM/SAM are maintained
 by the SAM/BAM Format Specification Working Group.
 .
 PacBio-produced BAM files are fully compatible with the BAM specification,
 but makes use of the extensibility mechanisms of the BAM specification to
 encode PacBio-specific information. The pbbam library provides tools to
 work with these files
 .
 This package contains the library header files.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
export LC_ALL=C.UTF-8
include /usr/share/dpkg/default.mk

DEB_VERSION_UPSTREAM := $(subst +ds,,$(DEB_VERSION_UPSTREAM))
generated_data_dir = $(CURDIR)/gendata

%:
	  dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DPacBioBAM_build_shared=ON \
	-DPacBioBAM_build_tests=OFF \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_SKIP_RPATH=ON \
	-DHTSLIB_INCLUDE_DIRS=/usr/include \
	-DHTSLIB_LIBRARIES="-lssl -lcrypto -lhts" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)"
#	-DPacBioBAM_wrap_python=ON \
#	-DPacBioBAM_wrap_r=ON

override_dh_auto_test: $(subst .t.in,.deb.t,$(wildcard tests/src/cram/pb*.t.in))
	mkdir -p $(generated_data_dir)
	python tests/scripts/generate_data.py $(CURDIR)/tests/data $(generated_data_dir)
	BINDIR=`find $$PWD -name bin -type d`; \
	LIBDIR=`find $$PWD -name lib -type d`; \
	PATH="$$BINDIR:$(PATH)" LD_LIBRARY_PATH="$$LIBDIR:$(LD_LIBRARY_PATH)" \
	cram -v $^

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

override_dh_auto_clean:
	dh_auto_clean
	find -name "*.deb.t" -delete
	$(RM) -r $(generated_data_dir)

%.deb.t: %.t.in
	sed \
	-e 's/$$BAM2SAM/samtools view/g' \
	-e 's/\-\-header\-only/-H/g' \
	-e 's/\-\-no\-header//g' \
	-e 's|@PacBioBAM_BinDir@/||g' \
	-e 's|$$TOOLS_BIN/||g' \
	-e 's|@PacBioBAM_TestsDir@|$(CURDIR)/tests|g' \
	-e 's|@PacBioBAM_VERSION@|$(DEB_VERSION_UPSTREAM)|g' \
	-e 's|@GeneratedTestDataDir@|$(generated_data_dir)|g' \
	$< > $@

=== debian/tests/control ===
Test-Command: debian/rules override_dh_auto_test
Depends:
	make,
	python,
	pbbamtools,
	python-cram,
Restrictions:
	needs-recommends,
	rw-build-tree,

## pbbam 0.19.0%2Bdfsg

=== tools/pbindex/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # create version header
 set(PbIndex_VERSION ${PacBioBAM_VERSION})
 configure_file(
-    ${PbindexSrcDir}/PbIndexVersion.h.in PbIndexVersion.h @ONLY
+    ${PbindexSrcDir}/PbIndexVersion.h.in ${GeneratedDir}/PbIndexVersion.h @ONLY
 )
 
 # list source files
